select 
  an.numero as nro
  , (case
      when coalesce((select avg(pesototal) from leite where cdlactacao = lac.cdlactacao and dtleite >= (current_date - 8)),100) <= 15 then 'm7<= 15'
      when uoco.diagnostico = 'P' then (uoco.dtpartoprovavel - cast((select valor from configuracao where nome = 'PeriodoDescanso') as integer))
    else null end) as secagem 
  , upar.data as partu
  , (current_date - lac.dtinicio) as del
  , (case
    when (select count(*) from animal where cdreproducao = upar.cdreproducao) > 1 then 'G'
    when upar.cdtipoparto = 3 then 'A'
    when upar.cdtipoparto = 4 then 'N'
    else coalesce(cria.sexo, upar.sexocria1, upar.sexocria2) end) as partr
  , ucio.data as ciou
  , ucob.data as cobu
  , (case when uoco.diagnostico = 'P' then 'Sim' else null end) as prenhez
  , (select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and
        re.data > (coalesce(upar.data, '1900-01-01')) and re.data >= upar.data) as NCOB
  , (current_date - ucob.data) as duc
  , (select avg(pesototal) from leite where cdlactacao = lac.cdlactacao and dtleite > (current_date - 8)) as m7
  , (select avg(pesototal) from leite where cdlactacao = lac.cdlactacao and dtleite > (current_date - 4)) as m3
  , (select avg(pesototal) from leite where cdlactacao = lac.cdlactacao and dtleite > (current_date - 2)) as m1
  , (select first 1 pesototal from leite where dtleite = (current_date - 1) and cdlactacao = lac.cdlactacao) as m0
  , se.nome as setor_atual
from 
  animal an
  join reproducao upar on upar.cdreproducao =
  	(select first 1 re.cdreproducao
  	from reproducao re
  	where re.cdtiporeproducao = 7
  	  and re.cdanimal = an.cdanimal
  	order by re.data desc)
  left join reproducao ucio on ucio.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = upar.cdanimal
      and ((re.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4))
        or (re.cio = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 3)))
    order by re.data desc)
  left join reproducao ucob on ucob.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = upar.cdanimal
      and re.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4)
    order by re.data desc)
  left join reproducao uoco on uoco.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = upar.cdanimal
       and ((re.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4 or cdtiporeproducao = 7))
         or (cio = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 3)) or (re.diagnostico is not null))       
    order by re.data desc) 
  left join animal cria on cria.cdanimal = 
    (select first 1 rea.cdanimal
    from animal rea
    where rea.cdreproducao = upar.cdreproducao)
  left join lactacao lac on lac.cdlactacao = 
    (select first 1 rel.cdlactacao
    from lactacao rel
    where rel.cdanimal = upar.cdanimal
    order by rel.dtinicio desc)
  left join setor se on se.cdsetor = an.cdsetor
where 1=1
  and an.tipoanimal = 'A'
  and an.animalrebanho = '1'
  and an.sexo = 'F'
  and an.cdcategoria = 7
  and an.dtbaixa is null
  and exists (select * from lactacao where dtfim is null and cdanimal = an.cdanimal)
  and se.nome = 
---ALTERAR O NOME DO SETOR AQUI. O NOME DEVE SER INFORMADO EXATAMENTE COMO ESTA NO IDEAGRI, ENTRE AS ASPAS SIMPLES.
  'Principal'
order by an.numordenado